#! /usr/bin/perl -w 

my $VERSION = '1.0';
my %list;

my $count=0;

sub prettyNum {
   my @qualifiers=( 'bytes', 'kilobytes', 'megabytes', 'gigabytes', 'terabytes' );
   $num = shift;
   my $qualifier = 0;
   while ( $num > 1024 ) {
      $num /= 1024;
      $qualifier++;
   }
#   print "$num\n";
#   print "$qualifier\n";
#   print $qualifiers[$qualifier];
#   die;
   return sprintf( '%0.2f %s', $num, $qualifiers[$qualifier] );
}
   
while ( $line = <> ) {
   if ( $line =~ m/^(\d+).*bytes each:/ ) {
      $count++;
      $list{$count}{'size'} = $1;
      $list{$count}{'numFiles'} = 0;
      while ( ( $line = <> ) !~ m/^$/ ) {
         $list{$count}{'files'} .= $line;
         $list{$count}{'numFiles'}++;
      }
      $list{$count}{'savings'} = ( $list{$count}{'numFiles'} -1 ) * $list{$count}{'size'};
   }
}

foreach $count ( sort{ $list{$b}{'savings'}<=>$list{$a}{'savings'}; } keys %list ) {
   print "-----You can save " . &prettyNum( $list{$count}{'savings'}) . " by removing all but one of the " . $list{$count}{'numFiles'} . " files below\n" . $list{$count}{'files'} . "\n";
}

1;